#!/bin/sh

if [ $# != 2 ]; then
    echo 1>&2 "usage: `basename $0` OUTPUT TEMPLATE"
    exit 1
fi
OUTPUT=$1
TEMPLATE=$2

set -e

rm -Rf $OUTPUT

# Build the library directories
for dir in common server shared; do
    src=$TEMPLATE/$dir/lib
    dst=$OUTPUT/$dir/lib
    for file in $src/*; do
	[ -d $dst ] || mkdir -p $dst
	if [ -L $file ]; then
	    tgt=`ls -l $file | sed 's:.* -> ::'`
	    tgtdir=`dirname $tgt`
	    tgtdir=`cd $src && cd $tgtdir && pwd`
	    ln -s $tgtdir/`basename $tgt` $dst/`basename $file`
        elif [ -e $file ]; then
	    cp -a $file $dst
	fi
    done
done
[ -f $TEMPLATE/common/preloads ] && \
    cp -a $TEMPLATE/common/preloads $OUTPUT/common

# Make the log directory
mkdir $OUTPUT/logs

# Make the configuration directory
mkdir $OUTPUT/conf
cp -a $TEMPLATE/conf/{jk2.properties,web.xml} $OUTPUT/conf

# Make the webapps directory
mkdir $OUTPUT/webapps
cp -a $TEMPLATE/webapps/{admin.xml,examples,manager.xml} $OUTPUT/webapps
