import java.io.File;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.NoInitialContextException;
import javax.naming.spi.NamingManager;

class TestNamingManager {

    // Check that javax.naming.spi.NamingManager is creating contexts
    // using the context classloader rather than whatever is the
    // default one (originally fixed in gcc-ssa-3.5ssa-0.20030801.41).
    // Amongst other things, failure here will cause Tomcat to fail to
    // start when running with JMX MBeans support.

    public static void main(String[] args) {

	try {
	    ClassLoader classloader = new URLClassLoader(new URL[] {new URL(
	        "file://" + System.getProperty("user.dir") +
		File.separator + "namingmanager" + File.separator)});

	    Thread.currentThread().setContextClassLoader(classloader);

	    Hashtable env = new Hashtable();
	    env.put(Context.INITIAL_CONTEXT_FACTORY, "TestContextFactory");

	    try {
		Context context = NamingManager.getInitialContext(env);
	    }
	    catch (NoInitialContextException e) {
		Throwable t = e.getRootCause();
		if (t != null && t.getClass() == ClassNotFoundException.class)
		    System.out.println("ClassNotFoundException");
		else
		    throw e;
	    }
	}
	catch (Exception e) {
	    e.printStackTrace(System.out);
	}

    }
}
