from harness.testsuite import TestCase

class SolibTestCase(TestCase):
    webapp = "solib-test"
    deploy = 1

    # Run after normal tests to maximize the number of loaded libraries.
    order = 90

    # Check that shared libraries in the common, server and shared
    # classloader directories are all registered to the correct
    # classloader.  This may not be the case if the preloads file is
    # incorrect.
    def testSolibs(self):
        r = self.getSession().GET("")
        self.assertEqual(r.status, 200)
        self.assertEqual(r.headers.type, "text/plain")
        for line in r.lines:
            loader, lib = line.split(" => ")
            self.failUnless(lib.startswith(loader))
