import gnu.gcj.runtime.SharedLibHelper;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.ref.WeakReference;
import java.util.Iterator;
import java.util.HashMap;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class ListServlet extends HttpServlet {

    public void doGet(HttpServletRequest req, HttpServletResponse resp)
	throws ServletException, IOException
    {
	resp.setContentType("text/plain");
        PrintWriter out = resp.getWriter();

	// Build a mapping of classloader names
	HashMap loaders = new HashMap();
	{
	    ClassLoader loader = this.getClass().getClassLoader();
	    loaders.put(loader, "webapp");

	    String[] names = new String[]{"server", "common", "system"};
	    for (int i = 0; i < names.length; i++) {
		loader = loader.getParent();
		loaders.put(loader, names[i]);
	    }
	}

	// Build a mapping of relative library names
	HashMap libs = new HashMap();
	{
	    String[] dirs = new String[]{"common", "server", "shared"};
	    for (int i = 0; i < dirs.length; i++) {
		File dir = new File(
		    System.getProperty("catalina.base") + File.separator +
		    dirs[i] + File.separator + "lib");
		String files[] = dir.list();
		for (int j = 0; j < files.length; j++)
		    if (files[j].endsWith(".so"))
			libs.put((new File(dir, files[j])).getCanonicalPath(),
				 dirs[i] + File.separator + "lib"
				 + File.separator + files[j]);
	    }
	}

	// Build a mapping of loaded libraries' loaders.
	HashMap loadedby = new HashMap();
	try {
	    HashMap map = (HashMap) SharedLibHelper.class.
		getDeclaredField("map").get(null);

	    synchronized (map) {
		Iterator iter = map.keySet().iterator();
		while (iter.hasNext()) {
		    String lib = (String) iter.next();
		    SharedLibHelper helper =
			(SharedLibHelper) ((WeakReference) map.get(lib)).get();

		    ClassLoader loader = (ClassLoader) SharedLibHelper.class.
			getDeclaredField("loader").get(helper);

		    loadedby.put(libs.get(lib), loaders.get(loader));
		}
	    }
	}
	catch (Exception e) {
	    e.printStackTrace(out);
	} 

	// Print the results
	{
	    Iterator iter = libs.keySet().iterator();
	    while (iter.hasNext()) {
		String lib = (String) libs.get(iter.next());
		String loader = (String) loadedby.get(lib);
		if (loader == null)
		    loader = "(null)";
		out.println(loader + " => " + lib);
	    }
	}

    }

}
